'
' This program is a merge of two freeware products:
'
' PBMODX, a mode X library, originally written by Matt Pritchard,
'         modified for use with PB by Dave Navarro
'
' GIFUnit, the GIF decoder. Originally written by Rich Geldreich, adapted
'          for PB by Thaddy de Koning.
'
' It's easy to modify this GIF Decoder for other Mod-X libs:
' Just change the pixel plot command into the appropriate alternative.
'
' And nope, no docs. But it's not very difficult to figure out what's
' happening, since most of the stuff is pretty self-explaining.
'
' * It's only tested in 320x200x256, no other resolutions! *
'
' Marc van den Dikkenberg,
' The Netherlands
'
' Visit my PB Webpage, at:
' http://pitel_lnx.ibk.fnt.hvu.nl/~excel/pb.html
'

$LINK "MODEX.PBL"
DEFINT A-Z

DECLARE SUB ERROR.OUT (Message$)
DECLARE FUNCTION GET.KEY% ()
DECLARE SUB PRINT.TEXT (Text$, Xpos%, Ypos%, ColorF%, ColorB%)
DECLARE SUB TPRINT.TEXT (Text$, Xpos%, Ypos%, ColorF%)
DECLARE SUB LOADPXL (filename$, act%, cur%)

TYPE ShapeType
	ImgData AS STRING * 512
	xWidth  AS INTEGER
	yWidth  AS INTEGER
END TYPE

TYPE Sprite
	Xpos    AS INTEGER
	Ypos    AS INTEGER
	XDir    AS INTEGER
	YDir    AS INTEGER
	Shape   AS INTEGER
END TYPE

$INCLUDE "UTILS.INC"
$INCLUDE "MODEX.INC"

%MaxShapes = 32

DIM Img(32) AS SHARED ShapeType
	INIT.RANDOM
	LOAD.SHAPES
	PAGE.DEMO
	SET.VIDEO.MODE 3
END

SUB ERROR.OUT (Message$)

	SET.VIDEO.MODE 3
	PRINT Message$
	END

END SUB

FUNCTION GET.KEY%

	DO
		X = SCAN.KEYBOARD
	LOOP UNTIL X

	GET.KEY% = X

END FUNCTION

SUB LOAD.SHAPES
DIM Grid(1 TO 32, 1 TO 32)
	FOR Shape = 0 TO %MaxShapes - 1
		FOR Y = 1 TO 32
		FOR X = 1 TO 32
			Grid(X, Y) = 0
		NEXT X
		NEXT Y

				xWidth = 16
				yWidth = 16

			FOR Y = 1 TO yWidth
				FOR X = 1 TO xWidth
					Grid(X, Y) = X
				NEXT X
			NEXT Y

		Img(Shape).xWidth = xWidth
		Img(Shape).yWidth = yWidth

		A$ = STRING$(xWidth * yWidth, nil)
		c = 1

		FOR Y = 1 TO yWidth
			FOR X = 1 TO xWidth
				MID$(A$, c, 1) = CHR$(Grid(X, Y))
				c = c + 1
			NEXT X
		NEXT Y

		Img(Shape).ImgData = A$

	NEXT Shape

END SUB

SUB PAGE.DEMO

%MaxSprites = 20

DIM Obj(%MaxSprites) AS Sprite
DIM LastX(%MaxSprites, 1), LastY(%MaxSprites, 1)
DIM LastObjects(1)

	ScreenX = 320: ScreenY = 200

	IF SET.VGA.MODEX%(%Mode320x200, ScreenX, ScreenY, 3) = 0 THEN
		ERROR.OUT "Unable to SET.VGA.MODEX" + STR$(Mode)
	END IF

	SET.ACTIVE.PAGE 0
	CLEAR.VGA.SCREEN %c.BLACK

dim tim2 as double
dim tim as double
tim=timer
'
' These three lines are used used to display the time
' it took to load and display the GIF
'
    set.active.page 1
    GIF "demo.gif",1
    copy.page 1,0
'
' Decode the GIF on page 1, then copy it to page 0, where it becomes
' visible. This way, you can't see the picture being drawn.
'
    SET.ACTIVE.PAGE 0

tim2=timer
tprint.text str$(tim2-tim),10,10,10
'
' And display the time it has taken!
'

   COPY.PAGE 0, 1
	COPY.PAGE 0, 2

'  Copy pages, for sprite buffer


	FOR X = 1 TO %MaxSprites
		DO
			Obj(X).XDir = RANDOM.INT(7) - 3
			Obj(X).YDir = RANDOM.INT(7) - 3
		LOOP WHILE (Obj(X).XDir = 0 AND Obj(X).YDir = 0)

		Obj(X).Shape = X MOD %MaxShapes

		SpriteX = Img(Obj(X).Shape).xWidth
		SpriteY = Img(Obj(X).Shape).yWidth

		Obj(X).Xpos = 1 + RANDOM.INT(ScreenX - SpriteX - 2)
		Obj(X).Ypos = 1 + RANDOM.INT(ScreenY - SpriteY - 2)

		LastX(X, 0) = Obj(X).Xpos
		LastX(X, 1) = Obj(X).Xpos
		LastY(X, 0) = Obj(X).Ypos
		LastY(X, 1) = Obj(X).Ypos
	NEXT X

	CurrentPage = 0

	'View Shift...

'	SetColor  = 3: SDir = 1
'	PrevColor = 0: PDir = 1
'     Cycle colours

	VisObjects = %MaxSprites \ 2
	LastObjects(0) = 0
	LastObjects(1) = 0

DRAW.LOOP:

	SET.ACTIVE.PAGE CurrentPage
'
'	' Erase Old Images
'
	FOR X = 1 TO LastObjects(CurrentPage)

		X1 = LastX(X, CurrentPage) AND &HFFFC
		Y1 = LastY(X, CurrentPage)
		X2 = ((LastX(X, CurrentPage) + Img(Obj(X).Shape).xWidth)) OR 3
		Y2 = Y1 + Img(Obj(X).Shape).yWidth - 1

		COPY.BITMAP 2, X1, Y1, X2, Y2, CurrentPage, X1, Y1

	NEXT X
'
'	' Draw new images

	FOR X = 1 TO VisObjects

		SpriteX = Img(Obj(X).Shape).xWidth
		SpriteY = Img(Obj(X).Shape).yWidth

		' Move Sprite

REDOX:
		NewX = Obj(X).Xpos + Obj(X).XDir
		IF NewX < 0 OR NewX + SpriteX > ScreenX THEN
			Obj(X).XDir = -Obj(X).XDir
			IF RANDOM.INT(20) = 1 THEN
				DO
					Obj(X).XDir = RANDOM.INT(7) - 3
					Obj(X).YDir = RANDOM.INT(7) - 3
				LOOP WHILE (Obj(X).XDir = 0 AND Obj(X).YDir = 0)
				GOTO REDOX
			END IF
		END IF
		Obj(X).Xpos = Obj(X).Xpos + Obj(X).XDir

REDOY:
		NewY = Obj(X).Ypos + Obj(X).YDir
		IF NewY < 0 OR NewY + SpriteY > ScreenY THEN
			Obj(X).YDir = -Obj(X).YDir
			IF RANDOM.INT(20) = 1 THEN
				DO
					Obj(X).XDir = RANDOM.INT(7) - 3
					Obj(X).YDir = RANDOM.INT(7) - 3
				LOOP WHILE (Obj(X).XDir = 0 AND Obj(X).YDir = 0)
				GOTO REDOY
			END IF
		END IF
		Obj(X).Ypos = Obj(X).Ypos + Obj(X).YDir

		'Draw Sprite

		TDRAW.BITMAP Img(Obj(X).Shape), Obj(X).Xpos, Obj(X).Ypos, SpriteX, SpriteY

		LastX(X, CurrentPage) = Obj(X).Xpos
		LastY(X, CurrentPage) = Obj(X).Ypos

	NEXT X

	LastObjects(CurrentPage) = VisObjects

	' Pan Screen Back & Forth

	ViewCnt = ViewCnt + 1
	IF ViewCnt >= ViewMax THEN
		ViewX = ViewX + ViewXD
		IF ViewX = 0 OR ViewX = 39 THEN ViewXD = -ViewXD
		IF ViewXD < 0 THEN
			ViewY = ViewY + ViewYD
			IF ViewY = 0 OR ViewY = 39 THEN ViewYD = -ViewYD
		END IF

		SET.WINDOW CurrentPage, ViewX, ViewY

		ViewCnt = 0
	ELSE
		SET.DISPLAY.PAGE CurrentPage
	END IF


	Code = SCAN.KEYBOARD

	IF Code = %False THEN GOTO DRAW.LOOP

	IF Code = %KyPlus THEN
		IF ViewMax < 12 THEN ViewMax = ViewMax + 1
		GOTO DRAW.LOOP
	END IF

	IF Code = %KyMinus THEN
		IF ViewMax > 1 THEN ViewMax = ViewMax - 1
		IF ViewCnt >= ViewMax THEN ViewCnt = 0
		GOTO DRAW.LOOP
	END IF

	IF Code = %KyUp THEN
		IF VisObjects < %MaxSprites THEN VisObjects = VisObjects + 1
		GOTO DRAW.LOOP
	END IF

	IF Code = %KyDown THEN
		IF VisObjects > 1 THEN VisObjects = VisObjects - 1
		GOTO DRAW.LOOP
	END IF


END SUB

SUB PRINT.TEXT (Text$, Xpos, Ypos, ColorF, ColorB)

	IF LEN(Text$) = 0 THEN EXIT SUB
	PRINT.STR STRSEG(Text$), STRPTR(Text$), LEN(Text$), Xpos, Ypos, ColorF, ColorB

END SUB

SUB TPRINT.TEXT (Text$, Xpos, Ypos, ColorF)

	IF LEN(Text$) = 0 THEN EXIT SUB

	TPRINT.STR STRSEG(Text$), STRPTR(Text$), LEN(Text$), Xpos, Ypos, ColorF

END SUB

'----[ GIF Decoder ]--------------------------------------


DECLARE SUB GIF(string,integer)

'PRINT "1: Autoscale Fullscreen  "
'PRINT "2: Scale X to Fullscreen "
'PRINT "3: Scale Y to Fullscreen "
'PRINT "4: Maximum resolution    "
'PRINT "5: Manual scaling        "
'INPUT "Select Option";Options

SUB GIF(A$,Options) LOCAL PUBLIC
DIM Prefix(4095), Suffix(4095), OutStack(4095)
DIM Ybase AS word, WorkCode AS integer
scaler=1
IF DIR$(A$)="" THEN EXIT SUB
OPEN A$ FOR BINARY AS #1
GET$ #1,6, A$

IF A$ <> "GIF87a" THEN
  PRINT "Not a GIF87a file."
  END
END IF

GET #1, , TotalX
GET #1, , TotalY
GOSUB GetByte
NumColors = 2 ^ ((a AND 7) + 1)
NoPalette = (a AND 128) = 0
GOSUB GetByte
Background = a
GOSUB GetByte

IF a <> 0 THEN
  PRINT "Bad screen descriptor."
  END
END IF

IF NoPalette = 0 THEN
  P$ = SPACE$(NumColors * 3)
  GET #1, , P$
END IF

DO
  GOSUB GetByte

  IF a = 44 THEN
    EXIT DO
  ELSEIF a <> 33 THEN
    PRINT "Unknown extension type."
    END
  END IF

  GOSUB GetByte

  DO
    GOSUB GetByte
    GET$ #1,a , A$
  LOOP UNTIL a = 0

LOOP

GET #1, , XStart
GET #1, , YStart
GET #1, , XLength
GET #1, , YLength
XEnd = XStart + XLength
YEnd = YStart + YLength

select case options

  case 1
    scaler = max(ylength\200,xlength\320)

  case 2
    scaler = xlength\320

  case 3
    scaler = ylength\200

  case 5
    LOCATE 20,10
    INPUT "Scaling factor (0-9)";scal#
    scaler = int(scal#)

  case else
    scaler = 1
end select

screenX??=320*scaler
GOSUB GetByte

IF a AND 128 THEN
  PRINT "Can't handle local colormaps."
'  END
END IF

Interlaced = a AND 64
PassNumber = 0
PassStep = 8
GOSUB GetByte
ClearCode = 2 ^ a
EOSCode = ClearCode + 1
FirstCode = ClearCode + 2
NextCode = FirstCode
StartCodeSize = a + 1
CodeSize = StartCodeSize
StartMaxCode = 2 ^ (a + 1) - 1
MaxCode = StartMaxCode
BitsIn = 0
BlockSize = 0
BlockPointer = 1
X = XStart
Y = YStart
Ybase = Y * ScreenX??
'kick into screen 13
'Reg 1,&h0013
'call interrupt &h10

DEF SEG = &HA000

IF NoPalette = 0 THEN
  OUT &H3C7, 0
  OUT &H3C8, 0

  FOR A = 1 TO NumColors * 3
    OUT &H3C9, ASC(MID$(P$, A, 1)) \ 4
  NEXT

END IF
DO
  GOSUB GetCode

  IF Code <> EOSCode THEN

    IF Code = ClearCode THEN
      NextCode = FirstCode
      CodeSize = StartCodeSize
      MaxCode = StartMaxCode
      GOSUB GetCode
      CurCode = Code
      LastCode = Code
      LastPixel = Code

		IF X < ScreenX??   THEN
'		  POKE X\scaler+2 + Ybase, LastPixel
set.point x,y,lastpixel
      END IF


      INCR X

      IF X = xend THEN
        GOSUB NextScanLine
      END IF

    ELSE
      CurCode = Code
      StackPointer = 0

      IF Code > NextCode THEN  'bad GIF if this happens
        EXIT DO
      END IF

      IF Code = NextCode THEN
        CurCode = LastCode
        OutStack(StackPointer) = LastPixel
        INCR StackPointer
      END IF

      DO WHILE CurCode >= FirstCode
        OutStack(StackPointer) = Suffix(CurCode)
        INCR StackPointer
        CurCode = Prefix(CurCode)
      LOOP

      LastPixel = CurCode

		IF  X < ScreenX??  THEN
'		  POKE X\scaler+2 + Ybase, LastPixel
set.point X,y,lastpixel
      END IF

      INCR X

      IF X = xend THEN
        GOSUB NextScanLine
      END IF

      FOR A = StackPointer - 1 TO 0 STEP -1

		  IF X < ScreenX??  THEN
'			 POKE X\scaler+2 + Ybase, OutStack(A)
set.point x,y,outstack(a)
        END IF

        INCR X

        IF X = xend THEN
          GOSUB NextScanLine
        END IF

      NEXT

      IF NextCode < 4096 THEN
        Prefix(NextCode) = LastCode
        Suffix(NextCode) = LastPixel
        INCR NextCode

        IF NextCode > MaxCode AND CodeSize < 12 THEN
          INCR CodeSize
          SHIFT LEFT MAXCODE,1
          INCR MAXCODE
        END IF

      END IF

      LastCode = Code
    END IF

  END IF

LOOP UNTIL DoneFlag OR Code = EOSCode

'A$ = INPUT$(1)
EXIT SUB

GetByte:
GET #1,, a?
a=a?
RETURN

NextScanLine:

IF Interlaced THEN
  Y = Y + PassStep

  IF Y >= YEnd THEN
    INCR PassNumber

    SELECT CASE PassNumber

      CASE 1
        Y = 4
        PassStep = 8

      CASE 2
        Y = 2
        PassStep = 4

      CASE 3
        Y = 1
        PassStep = 2
    END SELECT

  END IF

ELSE

  incr ytoggle

  if Ytoggle=scaler then
	 INCR Y
    ytoggle =0
  end if

END IF

X = XStart
Ybase = Y * ScreenX??\scaler
DoneFlag = Y > 199
RETURN

GetCode:

IF BitsIn = 0 THEN
  GOSUB ReadBufferedByte
  LastChar = A
  BitsIn = 8
END IF

WorkCode =LastChar
shift right workcode,8-bitsin

DO WHILE CodeSize > BitsIn
  GOSUB ReadBufferedByte
  LastChar = A
  shift left a,bitsin
  WorkCode = WorkCode OR A
  INCR BitsIn,8
LOOP

BitsIn = BitsIn - CodeSize
Code = WorkCode AND MaxCode
RETURN

ReadBufferedByte:

IF BlockPointer > BlockSize THEN
  GOSUB GetByte
  BlockSize = A
  GET$ #1,blocksize , A$
  BlockPointer = 1
END IF

A = ASC(MID$(A$, BlockPointer, 1))
INCR BlockPointer
RETURN
END SUB